import React, {
  useState,
  useCallback,
  useEffect,
} from 'react';
import ReactDOM from 'react-dom';
import { csv } from 'd3';

const csvUrl =
  'https://gist.githubusercontent.com/minwoopak/89107ac877ff2cb1741dfe08d91591d5/raw/cssNamedColors.csv';

const App = () => {
  const [data, setData] = useState(null);
  /*
  useEffect hook is needed whenever we do a side_effect(network request like fetching data).
  It lets you perform that side_effect only once.
  */
  useEffect(() => {
    csv(csvUrl).then(setData);
  }, []);

  if(!data) {
    return <pre>Loading...</pre>;
  }

  return data.map((d) => (
    <div
      style={{
        backgroundColor: d['RGB hex value'],
        width: '960px',
        height: '4px',
      }}
    />
  ));
};

const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
